from datatypes import *


class TypeConverter:

    def __init__(self):

        self.__types = {}



    def add_type(self, key, dtype):

        self.__types[key] = dtype



    #
    # The conversion methods must be idem-potent.
    #
    def str2type(self, key, v):

        dtype = self.__types.get(key, TYPE_STRING)
        
        if (dtype == TYPE_STRING): return v
        elif (dtype == TYPE_BOOL):
            return (v == "true" or v == 1)
        elif (dtype == TYPE_INT): return int(v)
        elif (dtype == TYPE_FLOAT): return float(v)
        elif (dtype == TYPE_LIST):
            v = v.replace("\\,", "@@COMMA@@")
            parts = v.split(",")
            ret = []
            for p in parts: ret.append(p.strip().replace("@@COMMA@@", ","))
            return ret
        else:
            return v




    #
    # The conversion methods must be idem-potent.
    #
    def type2str(self, key, v):

        dtype = self.__types.get(key, TYPE_STRING)

        if (dtype == TYPE_LIST): return ",".join(v)
        elif (dtype == TYPE_BOOL): return v and "true" or "false"
        else: return str(v)
